;============================================================================
;PROJEKT:  CDpanel
;DATUM:    11/1998
;AUTOR:    Papouch s.r.o. - www.papouch.com
;===========================================================================
;Popis:    Ovladaci panel k CD-ROM
;===========================================================================
;Licence:  Pouziti pouze pro nekomercni ucely!
;          V pripade zajmu o komercni pouziti kontaktujte Papouch s.r.o.
;===========================================================================

PCON    DATA    87H
SUBCH0  DATA    7FH
SUBCH1  DATA    7EH  ; audio status
SUBCH2  DATA    7DH
SUBCH3  DATA    7CH
SUBCH4  DATA    7BH
SUBCH5  DATA    7AH
SUBCH6  DATA    79H  ; current track
SUBCH7  DATA    78H
SUBCH8  DATA    77H
SUBCH9  DATA    76H
SUBCHA  DATA    75H
SUBCHB  DATA    74H
SUBCHC  DATA    73H
SUBCHD  DATA    72H
SUBCHE  DATA    71H
SUBCHF  DATA    70H
TOC0    DATA    6FH
TOC1    DATA    6EH
TOC2    DATA    6DH
TOC3    DATA    6CH  ; posledni track
TOC4    DATA    6BH
TOC5    DATA    6AH
TOC6    DATA    69H
TOC7    DATA    68H
TOC8    DATA    67H
TOC9    DATA    66H  ; M
TOCA    DATA    65H  ; S
TOCB    DATA    64H  ; F
ENDM	DATA	63H  ; posledni M
ENDS	DATA	62H  ; posledni S
ENDF	DATA	61H  ; posledni F

GADR    DATA    5FH
GBYTES  DATA    5EH
OLDDI   DATA    5DH  ; posledni stav displeje
ACTTR   DATA    5CH  ; navoleny track
DTIME   DATA    5BH  ; pamet pro zhasnuti displeje
BITSA   DATA    2FH
BITSB   DATA    2EH


R       BIT     P3.7
W       BIT     P3.5
A4      BIT     P3.4
A3      BIT     P3.3
A2      BIT     P3.2
A1      BIT     P3.1
A0      BIT     P3.0
ERRREAD BIT     BITSA.0 ; jak dopadlo paketove cteni
DISCIN  BIT     BITSA.1 ; je vlozen disk a nacten TOC
ENDDISC BIT     BITSA.2 ; disk dohral
PLAYYES BIT     BITSA.3 ; prehravani bezi
REPONE  BIT     BITSA.4 ; opakovani 1
REPALL  BIT     BITSA.5 ; opakovani vsech
PAUSE   BIT     BITSA.6 ; stav PAUSE
NOSEND  BIT     BITSA.7 ; nepodarilo se odeslat povel
NEWTR   BIT     BITSB.0 ; v dobe PAUSE bylo plus, nebo minus
DARK    BIT     BITSB.1 ; displej tmavy
NOBLIK  BIT     BITSB.2 ; zakaz blikani
MANSTOP BIT     BITSB.3 ; zastaveni bylo z klavesnice

        JMP     START

        ORG     30H
        DB      '$VER: CDC 3.2 (17.11.98)',0

        ORG     100H

START:  SETB    W
        SETB    R
        MOV     P1,#0FFH
        MOV     IE,#00H
        MOV     SP,#30H
        MOV     PSW,#0H
        MOV     A,#150D
        LCALL   DISP
        MOV     PCON,#00H
        MOV     BITSA,#0
        MOV     BITSB,#0
        MOV     DTIME,#10
	MOV     R7,#255
	MOV	OLDDI,#0D
WAIT1:  LCALL   DELAY
        DJNZ    R7,WAIT1
	LCALL	INIT
	LCALL	ZACAT
RST:	LCALL	INIT
FIRGET: LCALL   DELAY
        LCALL   DELAY
        LCALL   DELAY
        LCALL   DELAY
        LCALL   DELAY
        CLR     PAUSE
        CLR     REPALL
        CLR     REPONE
        CLR     DISCIN
        CLR     NEWTR
        CLR     ENDDISC
FIR1:   MOV     ACTTR,#0AAH       ; zacne se prvni stopou
        LCALL   GETTOC         ; nacteni hlavicky
	LCALL   STAT
        ANL     A,#09H         ; kontrola platnosti dat a citelnosti
	JNB	ERRREAD,FIRD
	MOV	A,#0FFH		

FIRD:   push    acc
        mov     A,#88D
        lcall   disp
        pop     acc


        JZ      FIR21
        LCALL   DELAY
        MOV     A,#00D          ; signalizuje, ze se ceka na CD ROM
        LCALL   DISP
        LCALL   KEYS           ; jen load a eject

        JMP     FIRGET

FIR21:	LCALL	GETEND		;nacte MFS adresu konce CDcka -lead out area
FIR2:   MOV     A,TOC3         
        LCALL   DISP
        SETB    DISCIN
        SETB    MANSTOP
        MOV     DPTR,#PAUSA
        LCALL   SEND
FIR3:   JB      ENDDISC,LOOP
        JB      PAUSE,LOOP
LOOP4:  JB      MANSTOP,LOOP
        LCALL   PLAY

LOOP:   LCALL   DELAY
        LCALL   KEYS
        LCALL   ITSPLAY
        JNB     DISCIN,RSTA
        JNB     PLAYYES,LOOP1
        MOV     A,SUBCH6
        JB     REPONE,LOOP2
	JB	REPALL,LOOP5
	MOV     ACTTR,A
        LCALL   DISP
        JMP     LOOP
LOOP2:   CJNE    A,ACTTR,LOOP4	;toto zde neni udelano nijak idealne
LOOP5:	PUSH	ACC		; je to proste nasilne vklineno do jiz vytvorene struktury programu
	MOV	A,R4
	SUBB	A,#128D
	POP	ACC
	JC	LOOP
	DEC	R4
	CJNE	R4,#128D,LOOP
	MOV     ACTTR,A
        LCALL   DISP
        JMP     LOOP

RSTA:	LJMP	RST
LOOP1:  MOV     A,OLDDI
        LCALL   DISP
        JB      PAUSE,LOOP
        JB      NEWTR,FIR3
        JB      REPONE,LOOP4
        MOV     ACTTR,#1
        JB      REPALL,LOOP4
        SETB    ENDDISC
        JMP     FIR2


ITSPLAY:
        LCALL   CURRENT
        JB      ERRREAD,ITP2
        MOV     A,SUBCH1
        CJNE    A,#011H,ITP0
        SETB    PLAYYES
      	JB	REPONE,ITP4
	JB	REPALL,ITP4
	RET
ITP4:	MOV	A,R4
	SUBB	A,#128D
	JNC	ITP3
	DJNZ	R4,ITP3
	MOV	R4,#255D
	MOV	A,#1FH
	JB	REPONE,ITP5
	MOV	A,#2FH
ITP5:	LCALL	DISPDIR
	RET

ITP0:   CLR     PLAYYES
        RET

ITP2:   CLR     PLAYYES
        CLR     DISCIN
        LCALL   DELAY
        MOV     DPTR,#PAUSA
        LCALL   SEND
ITP3:   RET



KEYS:   MOV     P3,#11111000B ; nacteni klaves
        LCALL   READ
        ORL     A,#11000000B  ; maskovani neexistujicich tlacitek
        CJNE    A,#0FFH,KEY1  ; neco je stisknuto
        RET
KEY1:   MOV     R3,A
        JNB     DARK,KEY4     ; uprava pri stisknuti v dobe temna
        SETB    NOBLIK
        MOV     DTIME,#10
        MOV     A,OLDDI
        LCALL   DISP
KEY4:   MOV     A,R3
        LCALL   MAKE

        MOV     R7,#180D
KEY2:   LCALL   DELAY
        LCALL   READ
        ORL     A,#11000000B  ; maskovani neexistujicich tlacitek
        CJNE    A,#0FFH,KEY3  ; ceka na pusteni
        CLR     NOBLIK
        RET
KEY3:   DJNZ    R7,KEY2
        CLR     NOBLIK
        RET

MAKE:   JNB     ACC.0,LOEJ
        JNB     DISCIN,MAKEX  ; kdyz neni disk, nic jineho nefunguje

        JB      ACC.4,MAKE2   
        JMP     PSTOP
MAKE2:  JB      ACC.2,MAKE3
        JMP     MINUS
MAKE3:  JB      ACC.5,MAKE4
        MOV     A,ACTTR
        LCALL   DISP
        JMP     PLAY
MAKE4:  JB      ACC.3,MAKE1
        JMP     PLUS
MAKE1:  JNB      ACC.1,REPEAT
MAKEX:  RET


LOEJ:   MOV     A,#150D      
        LCALL   DISP         
	JNB	PLAYYES,VYSUN	
	CLR	REPONE		; pokud hraje disk, je stopnut, a take je stopnut repeat
	CLR	REPALL
	MOV	DPTR,#STOP
	LCALL	SEND
	SJMP	LOEJ1
VYSUN: 	LCALL	TRAY		; identifikuje stav traye
	CJNE	A,#71H,EJ
	MOV	DPTR,#LOAD	; je vysunut pak zasun
	LCALL	SEND
	SJMP	LOEJ1
EJ:	MOV     DPTR,#EJECT   	; je zasunut pak vysun
        LCALL   SEND        
LOEJ1:  LCALL   STAT
        JB      ACC.7,LOEJ1
        JMP     MAKEX

REPEAT: MOV     R0,OLDDI
        MOV     A,#0FFH
        LCALL   DISPDIR
        MOV     R7,#20D
REP1:   LCALL   DELAY
        DJNZ    R7,REP1
        JB      REPALL,REP3
        JB      REPONE,REP4
        SETB    REPONE
        MOV     A,#1FH
        LCALL   DISPDIR
        JMP     REP5
REP3:   CLR     REPALL
        MOV     A,#0FH
        LCALL   DISPDIR
        JMP     REP5
REP4:   CLR     REPONE
        SETB    REPALL
	MOV	A,#2FH
        LCALL   DISPDIR
REP5:   MOV     R7,#150D
REP2:   LCALL   DELAY
	LCALL	DELAY
        DJNZ    R7,REP2
        MOV     A,R0
        LCALL   DISP
        JMP     MAKEX

PLAY:  
PLAY3:  MOV     DPTR,#PAUSA
        LCALL   SEND
PLAY3A: LCALL   STAT
        JB      ACC.7,PLAY3A
PLAY1:  LCALL   GETTOC       ; muze nekdy trvat velmi dlouho
	JB	ERRREAD,PLAY1
        LCALL   STAT
        ANL     A,#09H         ; kontrola platnosti dat a citelnosti
        JNZ      PLAY2

PLAY2:  MOV     DPTR,#XPLAY
	LCALL	SEND
        JNB     NOSEND,PLAY4
        MOV     R7,#255D
PLAY5:  LCALL   DELAY        ; strpeni navic
        LCALL   DELAY
        LCALL   DELAY
        LCALL   DELAY
        LCALL   DELAY
        LCALL   STAT
        JNB     ACC.7,PLAY4
        DJNZ    R7,PLAY5
PLAY4:  MOV     R7,#255D
PLAY4A: LCALL   DELAY
        DJNZ    R7,PLAY4A
        CLR     NEWTR
        CLR     PAUSE
        CLR     MANSTOP
        SETB    PLAYYES
        CLR     ENDDISC
        JMP     MAKEX

PLAY6:  JB      NEWTR,PLAY3  ; kdyz bylo plus-minus v dobe pause
        MOV     DPTR,#RESUME
        LCALL   SEND
        JNB     NOSEND,PLAY4
        MOV     R7,#255D
        SJMP    PLAY5


PSTOP:  JB      PAUSE,PLAY6
        MOV     DPTR,#PAUSA
        LCALL   SEND
        SETB    PAUSE
        MOV     A,ACTTR
        LCALL   DISP
        LCALL   DELAY
        JMP     MAKEX


MINUS:  MOV     A,ACTTR
        CJNE    A,#1,MIN1
        JMP     MAKEX
MIN1:   DEC     ACTTR
        JMP     MINPL

PLUS:   MOV     A,ACTTR
        MOV     R0,TOC3
        CLR     C
        SUBB    A,R0
        JC      PLUS1
        JMP     MAKEX
PLUS1:  INC     ACTTR
        JMP     MINPL

MINPL:  JNB     MANSTOP,MINPL0
        CLR     MANSTOP
        SETB    PAUSE
MINPL0: CLR     DARK
        CLR     ENDDISC
        CLR     ET0
        MOV     A,ACTTR
        LCALL   DISP
        MOV     DPTR,#PAUSA
        LCALL   SEND
        MOV     R7,#50D
MINPL1: LCALL   DELAY      ; pocka se, jestli neni vic kroku
        DJNZ    R7,MINPL1
        SETB    NEWTR
        MOV     P3,#11111000B ;autorepeat
        LCALL   READ
        JNB     ACC.2,MINUS
        JNB     ACC.3,PLUS
        SETB    ET0
        MOV     R7,#255D
MINPL2: PUSH    7
        LCALL   DELAY
        MOV     P3,#11111000B ;autorepeat
        LCALL   READ
        POP     7
        JNB     ACC.2,MINUS
        JNB     ACC.3,PLUS
        DJNZ    R7,MINPL2
        JMP     MAKEX


WRITE:  NOP
        CLR     W
        NOP
        NOP
        SETB    W
        RET

READ:   MOV     P1,#0FFH
        NOP
        NOP
        CLR     R
        NOP
        NOP
        MOV     A,P1
        SETB    R
        RET

STAT:   PUSH    P3
        MOV     P3,#11100111B
        LCALL   READ
        POP     P3
        RET

SEND:   CLR     NOSEND
        MOV     P3,#11100111B       ; cmd
        MOV     P1,#0A0H            ; packet command
        LCALL   WRITE
SEND5:	LCALL	STAT
	JB	ACC.7,SEND5
        MOV     R7,#06
SEND1:  CLR     A
        LCALL   GETB
        MOV     R5,A
        LCALL   GETB
        MOV     P3,#11110000B       ; high byte
        MOV     P1,A
        NOP
        NOP
        CLR     W
        NOP
        NOP
        SETB    W
        MOV     P3,#11100000B
        MOV     P1,R5
        NOP
        NOP
        CLR     W
        NOP
        NOP
        SETB    W
        DJNZ    R7,SEND1
	MOV	R5,#255D		
SEND4:  MOV     R7,#255D
SEND3:  LCALL   DELAY
	LCALL	DELAY
	LCALL	DELAY
        LCALL   STAT
        JNB     ACC.7,SEND2
        DJNZ    R7,SEND3
	DJNZ	R5,SEND4
        SETB    NOSEND
;SEND4:	LCALL	STAT
;	JNB	ACC.7,SEND2
;	JNB	ACC.0,SEND4
;	SETB	NOSEND
SEND2:  MOV     P3,#11100010B  ;interrupt reason reg.
        LCALL   READ
        RET

GETB:   CLR     A		; zachovano z puvodni prg
        MOVC    A,@A+DPTR
        INC     DPTR                
        CJNE    A,#0AAH,GETB1       ; AAH=cislo tracku
        MOV     A,ACTTR

GETB1:				; uklada data TOC 1. tracku (#ABH-#ADH)
	MOV	R2,A		; a o lead out area (#ADH-#B0H)
	SUBB	A,#0ABH		; podle jejich cisla se vypocte adresa, kam se tato data ulozi
	JC	GETBK		; TOC od TOC9 a lead out od ENDM
	MOV	R1,A		;jelikoz intel nema instrukci pro porovnani (vetsi mensi)
	SUBB	A,#6D
	JNC	GETBK
	MOV	A,R1
	MOV	R1,#TOC9
	XCH	A,R1
	CLR	C
	SUBB	A,R1
	MOV	R1,A
	MOV	A,@R1		
	RET
GETBK:	MOV	A,R2
	RET


GETTOC: MOV     DPTR,#TOC
        MOV     GADR,#TOC0
        MOV     GBYTES,#6
        JMP     GET

CURRENT: MOV    DPTR,#SUBCH
        MOV     GADR,#SUBCH0
        MOV     GBYTES,#4
        JMP     GET

GET:    LCALL   SEND
	JB	NOSEND,GETKON
        CLR     ERRREAD
        MOV     R1,GADR
        MOV     R6,GBYTES
GET3:   MOV     R7,#255        ; paketove cteni
GET1:   LCALL   STAT	
        JB      ACC.3,GET2
        DJNZ    R7,GET1
GETKON: SETB    ERRREAD        ; data nejsou READY
        RET
GET2:   MOV     P3,#11100000B
        MOV     P1,#0FFH
        CLR     R
        NOP
        nop
        nop
        nop
        nop
        nop
        MOV     @R1,P1
        SETB    R
        DEC     R1
        MOV     P3,#11110000B       ; high byte
        MOV     P1,#0FFH
        CLR     R
        NOP
        NOP
        NOP
        NOP
        NOP
        MOV     @R1,P1
        SETB    R
        DEC     R1
        DJNZ    R6,GET3
        MOV     P3,#11100010B  ;interrupt reason reg.
        LCALL   READ
	RET


DISPDIR:             ; zobrazuje primo
        PUSH    P3
;        MOV     OLDDI,A
        SETB    A3
        SETB    A4
        MOV     P1,A
        CLR     W
        NOP
        NOP
        SETB    W
        POP     P3
        RET

DISP: 
        PUSH    P3
        MOV     OLDDI,A
        JB      NOBLIK,DISP1
        JB      PAUSE,DISP3
        JB      ENDDISC,DISP4
        JMP     DISP1
DISP3:  DEC     DTIME     ; pro PAUSE
        MOV     R7,DTIME
        CJNE    R7,#0,DISP3A
        MOV     DTIME,#20D
        CPL     DARK
DISP3A: JNB     DARK,DISP1
        MOV     A,#0FFH
        JMP     DISP2
DISP4:  DEC     DTIME   ;   pro STOP
        MOV     R7,DTIME
        CJNE    R7,#0,DISP4A
        MOV     DTIME,#150D
        CPL     DARK
DISP4A: JNB     DARK,DISP1
        MOV     A,#0F1H
        JMP     DISP2
DISP1:  MOV     B,#10
        DIV     AB
        RL      A
        RL      A
        RL      A
        RL      A
        ANL     A,#0F0H
        ORL     A,B
DISP2:  SETB    A3
        SETB    A4
        MOV     P1,A
        NOP
        NOP
        CLR     W
        NOP
        NOP
        SETB    W
        POP     P3
        NOP
        RET

INIT:   MOV     P3,#11100110B ; drv
        MOV     P1,#0B0H   ; #0B0H pro slave, #0A0H pro master
        LCALL   WRITE
I1:	LCALL	STAT		; ceka na vysledek, pokud je po zapsani drive select FFH, tak neni
	JNB	ACC.7,I2	; neco v poradku a posle se tento zapis znovu
	CJNE	A,#0FFH,I1
	SJMP	INIT

I2:     MOV     P3,#11100100B ; bcl
        MOV     P1,#00H
        LCALL   WRITE
        LCALL   DELAY
        MOV     P3,#11100101B ; bch
        MOV     P1,#01H
        LCALL   WRITE
        LCALL   DELAY
        RET

DELAY:  PUSH    7          ; 2
        MOV     R7,#255    ; 2
DELAY1: NOP                ; 1
        NOP                ; 1    5*255+8 = 1283 cyklu
        NOP                ; 1            = 0.321 ms pro 4MHz
        DJNZ    R7,DELAY1  ; 2
        POP     7          ; 2     * 255 = cca 81 ms
        RET                ; 2

ZACAT:	MOV	DPTR,#PAUSA	; inicializace pro Samsung 12x
	LCALL	SEND		; posle mu tam jednu instrukci naslepo
	MOV	P3,#11100111B
HL7:	LCALL	READ
	JB	ACC.7,HL7
	RET


GETEND:					; nacte MSF lead out area - konec CDcka
	MOV	R1,#TOC9
	MOV	R0,#ENDM		; a ulozi ho na adresy ENDM, ENDS a ENDF
	MOV	R7,#3D
GEJMP:	MOV	A,@R1
	MOV	@R0,A
	DEC	R1
	DEC	R0
	DJNZ	R7,GEJMP
	MOV	ACTTR,#1D
	LCALL	GETTOC
	RET

TRAY:	MOV	DPTR,#MODE	;testuje, zda je tray otevreny nebo zavreny
	LCALL	SEND		;pouziva command mode sense
ZJ1:	LCALL	STAT
	JB	ACC.7,ZJ1

	MOV	R5,#2D		;nacte 3 a 4 byte informaci
ZJ2:	MOV	P3,#11100000B
	LCALL	READ
	DJNZ	R5,ZJ2
	RET


EJECT:  DB       1BH,00H,00H,00H,02H,00H,00H,00H,00H,00H,00H,00H
LOAD:   DB       1BH,00H,00H,00H,03H,00H,00H,00H,00H,00H,00H,00H
PAUSA:  DB       4BH,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
RESUME: DB       4BH,00H,00H,00H,00H,00H,00H,00H,01H,00H,00H,00H
XPLAY:  DB       47H,00H,00H,0ABH,0ACH,0ADH,0AEH,0AFH,0B0H,00H,00H,00H
TOC:    DB       43H,02H,00H,00H,00H,00H,0AAH,00H,0CH,00H,00H,00H
SUBCH:  DB       42H,02H,40H,01H,00H,00H,00H,00H,08H,00H,00H,00H
SENSE:	DB	 03H,00H,00H,00H,20H,00H,00H,00H,00H,00H,00H,00H
MODE:	DB	 5AH,00H,0DH,00H,00H,00H,00H,00H,04H,00H,00H,00H
STOP:   DB       4EH,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

        END
